'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _toolbar = require('@material/toolbar');

var _util = require('@material/toolbar/util');

var util = _interopRequireWildcard(_util);

var _Row = require('./Row');

var _Row2 = _interopRequireDefault(_Row);

var _styles = require('./styles.scss');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function normalizePropToReactStyle(property) {
  return property.replace(/(-.)/g, function (txt) {
    return txt.slice(1).toUpperCase();
  });
}

var Toolbar = function (_React$Component) {
  _inherits(Toolbar, _React$Component);

  function Toolbar() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Toolbar);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Toolbar.__proto__ || Object.getPrototypeOf(Toolbar)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      classes: new Set(),
      style: {},
      firstRowStyle: {}
    }, _this.foundation = new _toolbar.MDCToolbarFoundation({
      addClass: function addClass(className) {
        return _this.setState(function (prevState) {
          prevState.classes.add(_styles2.default[className] || className);
          return {
            classes: prevState.classes
          };
        });
      },
      removeClass: function removeClass(className) {
        return _this.setState(function (prevState) {
          prevState.classes.delete(_styles2.default[className] || className);
          return {
            classes: prevState.classes
          };
        });
      },
      hasClass: function hasClass(className) {
        return _this.allClasses.has(_styles2.default[className] || className);
      },
      registerScrollHandler: function registerScrollHandler(handler) {
        return window.addEventListener('scroll', handler, util.applyPassive());
      },
      deregisterScrollHandler: function deregisterScrollHandler(handler) {
        return window.removeEventListener('scroll', handler, util.applyPassive());
      },
      registerResizeHandler: function registerResizeHandler(handler) {
        return window.addEventListener('resize', handler);
      },
      deregisterResizeHandler: function deregisterResizeHandler(handler) {
        return window.removeEventListener('resize', handler);
      },
      getViewportWidth: function getViewportWidth() {
        return window.innerWidth;
      },
      getViewportScrollY: function getViewportScrollY() {
        return window.pageYOffset;
      },
      getOffsetHeight: function getOffsetHeight() {
        return _this.root ? _this.root.offsetHeight : 0;
      },
      getFirstRowElementOffsetHeight: function getFirstRowElementOffsetHeight() {
        if (_this.root && _this.root.firstChild) {
          // $FlowFixMe
          return _this.root.firstChild.offsetHeight;
        }
        return 0;
      },
      notifyChange: function notifyChange(_ref2) {
        var flexibleExpansionRatio = _ref2.flexibleExpansionRatio;

        if (_this.props.onChangeFlexible) {
          _this.props.onChangeFlexible({ flexibleExpansionRatio: flexibleExpansionRatio });
        }
      },
      setStyle: function setStyle(property, value) {
        _this.setState({
          style: _extends({}, _this.state.style, _defineProperty({}, normalizePropToReactStyle(property), value))
        });
      },
      setStyleForTitleElement: function setStyleForTitleElement(property, value) {
        if (_this.props.onUpdateTitleStyle) {
          _this.props.onUpdateTitleStyle(normalizePropToReactStyle(property), value);
        }
      },
      setStyleForFlexibleRowElement: function setStyleForFlexibleRowElement(property, value) {
        _this.setState({
          firstRowStyle: _extends({}, _this.state.firstRowStyle, _defineProperty({}, normalizePropToReactStyle(property), value))
        });
      },
      setStyleForFixedAdjustElement: function setStyleForFixedAdjustElement(property, value) {
        if (_this.props.onUpdateFixedToolbar) {
          _this.props.onUpdateFixedToolbar(normalizePropToReactStyle(property), value);
        }
      }
    }), _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Toolbar, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      // NOTE.- Still not sure if we have to wait for next tick to get computed
      // values of dom element on foundation
      setTimeout(function () {
        _this2.foundation.init();
      });
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.foundation.destroy();
    }
  }, {
    key: 'render',
    value: function render() {
      var _ref3,
          _this3 = this;

      var className = _classnames2.default.apply(undefined, [_styles2.default['mdc-toolbar']].concat(_toConsumableArray(this.state.classes), [(_ref3 = {}, _defineProperty(_ref3, _styles2.default['mdc-toolbar--flexible'], this.props.flexible), _defineProperty(_ref3, _styles2.default['mdc-toolbar--flexible-default-behavior'], this.props.flexible && this.props.flexibleDefault), _defineProperty(_ref3, _styles2.default['mdc-toolbar--fixed'], this.props.fixed), _defineProperty(_ref3, _styles2.default['mdc-toolbar--fixed-lastrow-only'], this.props.fixed && this.props.lastRow), _defineProperty(_ref3, _styles2.default['mdc-toolbar--waterfall'], this.props.fixed && this.props.waterfall), _ref3)]));

      this.allClasses = new Set(className.split(' '));

      return React.createElement(
        'header',
        {
          style: this.state.style,
          className: className,
          ref: function ref(root) {
            _this3.root = root;
          } },
        React.Children.map(this.props.children, function (child, index) {
          if (index === 0) {
            // $FlowFixMe: Needs to cast
            return React.cloneElement(child, {
              style: _this3.state.firstRowStyle
            });
          }
          return child;
        })
      );
    }
  }]);

  return Toolbar;
}(React.Component);

exports.default = Toolbar;
module.exports = exports['default'];